import React from "react";
import { getWord } from "../helpers/getWord";
import { validateInput } from "../helpers/validateInput";
import CharBox from "./CharBox";
import WordBox from "./WordBox";

const WordInput = () => {
    const NUM_TRY = 6;
    const WORD_LENGTH = 5;
    
    const [currentTry, setCurrentTry] = React.useState(0);
    const [word, setWord] = React.useState([]);
    const [allWords, setAllWords] = React.useState([]);
    const [inputBox, setInputBox] = React.useState([]);
    const [answer, setAnswer] = React.useState("");

    const resetInputBox = () => {
        const initInputBox = [];
        for (let i = 0; i < WORD_LENGTH; i++) {
            initInputBox.push(<CharBox char=""/>);
        }
        setInputBox(initInputBox);
        setWord([]);
    }

    const al = null;
    React.useEffect(() => {
        const charBoxes = [];
        getWord().then((response) => {
            if (response.error != undefined) {
                al =  alert("Error when get answer (" + response.error + ")");
            }
            setAnswer(response.res);
        });
        for (let i = 0; i < WORD_LENGTH; i++) {
            charBoxes.push({ char: "", answer: answer });
        }
        for (let i = 0; i < NUM_TRY; i++) {
            setAllWords(prev => [...prev, <WordBox chars={charBoxes} />]);
        }
        resetInputBox();
    }, []);

    document.onkeyup = async function(e) {
        if (e.key.length === 1){
            if (e.key.match(/[a-z]/i)) {
                if (word.length >= WORD_LENGTH) {
                    return;
                } else {
                    setInputBox(prevState => {
                        const newState = [...prevState];
                        newState[word.length] = <CharBox char={e.key} />;
                        return newState;
                    });    
                    setWord([...word, e.key]);         
                }
            }
        } else {
            if (e.key === "Enter") {
                // TODO: Check if user win
                // TODO: Check if user lose
                // TODO: Fix bug for character less than asked
                // TODO: Handle error to be served on Pop-up/Dialog box

                let currentInput = [];
                const validatedInput = await validateInput(word, answer);
                if (validatedInput["error"]) {
                    console.log(validatedInput["error"]);
                } else {
                    validatedInput["result"].flatMap((e, idx) => {
                        currentInput = [...currentInput, { char: word[idx], answer: e }];
                    });
                    setAllWords(prev => {
                        const newState = [...prev];
                        newState[currentTry] = <WordBox chars={currentInput} />;
                        return newState;
                    });
                    setCurrentTry(prev => prev + 1);
                    resetInputBox();
                }

            } else if (e.key === "Backspace" && word.length > 0) {
                setWord([...word.slice(0,-1)]);
                setInputBox(prevState => {
                    const newState = [...prevState];
                    newState[word.length-1] = <CharBox char={""} />;
                    return newState;
                });
            }
        }
    }
    
    return (
        <div className="word-input">
            {al}
            {allWords.slice(0, currentTry)}
            <div className="word-box input-box">
                {inputBox}
            </div>
            {allWords.slice(currentTry+1, NUM_TRY+1)}
        </div>
    );
}

export default WordInput;